/**
 * This will load scripts and css from given external cdn in the current document dinamically returning a
 * promise resolved when all necessary resources finish loading. It will use monaco-editor's AMD bundle. Usage
 * Example: `loadMonacoAmdFromExternalCdn('https://cdnjs.cloudflare.com/ajax/libs/monaco-editor/0.13.1/min/')`
 */
export declare const loadMonacoAmdFromExternalCdn: (baseUrl: string, container?: HTMLElement) => Promise<any[][]>;
/**
 * This will return an HTML snippet that will load scripts and css from given external cdn in the current
 * document dinamically returning a promise resolved when all necessary resources finish loading. It will use
 * monaco-editor's AMD bundle. Ideally if we are building our index.html at compile time using a template -
 * just put this string in the head or body. Using this technique monaco-editor will load faster than using
 * `loadMonacoAmdFromExternalCdn` since monaco-editor will start loading earlier.
 * @param vsRoot is something like `https://cdnjs.cloudflare.com/ajax/libs/monaco-editor/0.13.1/min/` (one
 * level before 'vs')
 */
export declare const monacoLoadAmdFromExternalCdnHtmlTemplate: (baseUrl: string) => string;
