"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const monacoFacade_1 = require("./monacoFacade");
const tsWorker_1 = require("./tsWorker");
let definitionProviderRegistered = false;
let lastProvidedDefinition;
let lastProvidedDefinitionPosition;
/** very dirty solution to navigate to other files on ctrl-click. Basically register a definition provide once providing
 * using language service based getMonacoDefinitionAtPosition and for each editor register a onMouseUp listener that
 * checks against the last provided definition in that position and set a new model to the editor, revealing position and
 * selecting the target Range.
 */
function install(editor, fn) {
    if (!definitionProviderRegistered) {
        monacoFacade_1.getMonaco().languages.registerDefinitionProvider('typescript', {
            provideDefinition(model, position, token) {
                lastProvidedDefinitionPosition = position;
                return new Promise(resolve => {
                    tsWorker_1.getMonacoDefinitionAtPosition(model, position).then(result => {
                        lastProvidedDefinition = result;
                        resolve(result);
                    });
                });
            }
        });
        definitionProviderRegistered = true;
    }
    editor.onMouseUp(e => {
        if (e.event.ctrlKey && e.target.position.equals(lastProvidedDefinitionPosition)) {
            //TODO: support multiple locations and return {model, loc}[]
            const def = (Array.isArray(lastProvidedDefinition) && lastProvidedDefinition.length ? lastProvidedDefinition[0] : lastProvidedDefinition);
            if (def) {
                const model = monacoFacade_1.getMonaco().editor.getModels().find(m => m.uri && def.uri && (m.uri.toString() === def.uri.toString()));
                if (model) {
                    fn(editor, model, def);
                }
            }
        }
    });
}
exports.install = install;
//# sourceMappingURL=navigateExternalDefinitions.js.map