/// <reference types="node" />
/**
 * this file administer opened editors and models globally and rresponsible of disposing / register them and some notifications
 */
import { EventEmitter } from 'events';
import * as monaco from 'monaco-editor';
import { AbstractFile, AbstractProject } from '../types';
export declare function getMonacoUriFromFile(file: AbstractFile | string): monaco.Uri;
export declare function uriToFileName(uri: monaco.Uri): string;
export declare function getMonacoModelFor(file: AbstractFile): monaco.editor.IModel;
export declare const monacoEditorEmitter: MonacoEditorEmitter;
export interface MonacoEditorEmitter extends EventEmitter {
    on(name: 'editorRegistered', listener: (editor: monaco.editor.ICodeEditor) => void): this;
    on(name: 'modelRegistered', listener: (model: monaco.editor.ITextModel, file: AbstractFile) => void): this;
    once(name: 'editorRegistered', listener: (editor: monaco.editor.ICodeEditor) => void): this;
    once(name: 'modelRegistered', listener: (model: monaco.editor.ITextModel, file: AbstractFile) => void): this;
}
export declare function registerEditor(editor: monaco.editor.ICodeEditor): void;
export declare function resetMonacoModelsAndEditors(): void;
export declare function createAllMonacoModelsFor(example: AbstractProject): void;
