"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * this file administer opened editors and models globally and rresponsible of disposing / register them and some notifications
 */
const events_1 = require("events");
const monacoFacade_1 = require("./monacoFacade");
// monaco editor models to files conversion helpers
function getMonacoUriFromFile(file) {
    return monacoFacade_1.getMonaco().Uri.file(typeof file === 'string' ? file : file.fileName);
}
exports.getMonacoUriFromFile = getMonacoUriFromFile;
function uriToFileName(uri) {
    return uri.fsPath.startsWith('/') ? uri.fsPath.substring(1, uri.fsPath.length) : uri.fsPath;
}
exports.uriToFileName = uriToFileName;
function getMonacoModelFor(file) {
    if (!file) {
        return monacoFacade_1.getMonaco().editor.createModel('', 'typescript', getMonacoUriFromFile('_black.ts'));
    }
    const uri = getMonacoUriFromFile(file);
    let model = monacoFacade_1.getMonaco().editor.getModels().find(m => m.uri.toString() === uri.toString() && !m.isDisposed());
    if (model) {
        return model;
    }
    model = monacoFacade_1.getMonaco().editor.createModel(file.content, undefined, uri);
    exports.monacoEditorEmitter.emit('modelRegistered', model, file);
    return model;
}
exports.getMonacoModelFor = getMonacoModelFor;
const editors = [];
// export const emitter: MonacoEditorEmitter = new EventEmitter()
exports.monacoEditorEmitter = new events_1.EventEmitter();
function registerEditor(editor) {
    // if (!editors.find(ed => ed === editor)) {
    editors.push(editor);
    exports.monacoEditorEmitter.emit('editorRegistered', editor);
    // }
}
exports.registerEditor = registerEditor;
// TODO: find a way of restarting tsserver
function resetMonacoModelsAndEditors() {
    monacoFacade_1.getMonaco().editor.getModels().forEach(model => model.dispose());
    editors.forEach(editor => editor.dispose());
}
exports.resetMonacoModelsAndEditors = resetMonacoModelsAndEditors;
function createAllMonacoModelsFor(example) {
    example.files.forEach(file => {
        getMonacoModelFor(file);
    });
}
exports.createAllMonacoModelsFor = createAllMonacoModelsFor;
//# sourceMappingURL=register.js.map