/**
 * this file is responsible of inspecting tsconfig.json and package.json if any and to identify the nature of the
 * project and load tsconfig.lib incase of TS or just lib.d.ts in case of JS (See installTypes.ts and comes later
 * to add more types - this is just lib.d.ts)
 */
import { AbstractProject } from '../types';
import * as ts from 'typescript';
/**
 * set compiled options in monaco defaults from tsconfig.json file in given project
 * also tsconfig lib[] are loaded from https://unpkg.com/typescript@2.9.2/lib/ and added with addExtraLib
 * TODO: wait until getTs() is true
 * @param project
 */
export declare function installTsConfig(project: AbstractProject): Promise<ProjectNature>;
export interface ProjectNature {
    type: 'typescript' | 'javascript' | 'unknown';
    extraLibAdded: Resource[];
    tsConfig: {
        fileName?: string;
        errorLoadingTsConfigJson?: Error;
        compilerOptions?: ts.CompilerOptions;
        libs: ResourceLoaded[];
        libsLoadingError?: Error;
        monacoSetCompilerOptionsError?: Error;
    };
    packageJson: {
        exists?: boolean;
        errorLoadingPackageJson?: boolean;
        libs: ResourceLoaded[];
        libsLoadingError?: Error;
    };
}
export interface Resource {
    fileName: string;
    url: string;
    content?: string;
}
export interface ResourceLoaded extends Resource {
    error?: Error;
}
