import { editor } from 'monaco-editor';
import React from 'react';
import { AbstractFile } from '../types';
declare type Props = {
    id?: string;
    file: AbstractFile;
    width?: string;
    height?: string;
    monacoEditorOptions?: editor.IEditorConstructionOptions;
};
/**
 * A React component ready to use, just give it the file, dimension and configuration as properties and it will render.
 */
export declare class Editor extends React.Component<Props> {
    /** the monaco-editor internal instance of this component */
    monacoEditor: editor.IStandaloneCodeEditor;
    containerId: string;
    render(): JSX.Element;
    componentDidUpdate(): void;
    componentDidMount(): void;
    defaultMonacoOptions: editor.IEditorConstructionOptions;
    installMonaco(): void;
    protected uninstallMonaco(): void;
    componentWillUnmount(): void;
    componentWillUpdate(): void;
    componentWillMount(): void;
}
export declare type EditorOptions = Props & {
    container: HTMLElement;
};
/**
 * Example:
 *
 * ```
 * const editor = renderEditor({container: document.getElementById('my-awesome-editor2')})
 * editor.monacoEditor.onKeyUp()..
 * ```
 * a function to render the editor with given it the fie, dimension, container and configuration as properties and it
 * will render for those not confortable with react
 */
export declare function renderEditor(options: EditorOptions): Editor;
export {};
