"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_sortable_tree_1 = __importDefault(require("react-sortable-tree"));
const fileTreeUtil_1 = require("../ui-util/fileTreeUtil");
const FileExplorerTheme = require('react-sortable-tree-theme-file-explorer');
// TODO : for performance move the onClick on the parent div (event delegation)
class FileTree extends react_1.Component {
    render() {
        if (!this.props.state.project) {
            return (react_1.default.createElement("div", null, "No project open"));
        }
        const treeData = this.getTestData();
        return (react_1.default.createElement("div", { style: { height: '100%' } },
            react_1.default.createElement(react_sortable_tree_1.default, { treeData: treeData, onChange: treeData => this.setState({ treeData }), theme: FileExplorerTheme, canDrag: true, generateNodeProps: rowInfo => ({
                    onClick: (event) => this.nodeClicked(event, rowInfo),
                    class: this.props.state.selectedFile === rowInfo.node.fileName ? 'selected' : '',
                    onContextMenu: (e) => { this.onContextMenu(e, rowInfo, this.props.state); }
                }) })));
    }
    getTestData() {
        return fileTreeUtil_1.filesToTreeNodes(this.props.state.project.files);
    }
    nodeClicked(event, rowInfo) {
        this.setSelectedFile(rowInfo.node);
    }
    onContextMenu(e, rowInfo, state) {
    }
    setSelectedFile(node) {
    }
}
exports.FileTree = FileTree;
//# sourceMappingURL=FileTree.js.map