export interface ScriptLoadDefinition extends ResourceLoadDefinition {
    scriptBody?: string;
    src?: string;
    async?: boolean;
    crossorigin?: Boolean;
}
export interface StyleLoadDefinition extends ResourceLoadDefinition {
    href?: string;
    styleBody?: string;
}
export interface ResourceLoadDefinition {
    container?: HTMLElement;
    callback?: (arg: any[]) => void;
}
export declare function loadScript(opts: ScriptLoadDefinition): Promise<any[]>;
export declare function loadCSS(opts: StyleLoadDefinition): Promise<any[]>;
export declare function loadSeries(opts: (ScriptLoadDefinition | StyleLoadDefinition)[]): Promise<any[][]>;
export declare function load(opts: ScriptLoadDefinition | StyleLoadDefinition): Promise<any[]>;
export declare function render(opts: (ScriptLoadDefinition | StyleLoadDefinition) | (ScriptLoadDefinition | StyleLoadDefinition)[]): string;
export declare function renderStyleLoadDefinition(opts: StyleLoadDefinition): string;
export declare function renderScriptLoadDefinition(opts: ScriptLoadDefinition): string;
